/***************************************************************************
                          keymapper_bindings.cpp  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#include "keymapper_bindings.h"

Evtmapper_bindings::~Evtmapper_bindings() {
 	iterator i=begin();
	while (i != end()) {
    delete *i;
  	i++;
	}
}	
	
void Evtmapper_bindings::add_keybinding(SDLKey sdlsym,int cmdfunction,char *config_name, char *display_name) {
	Evtmapper_binding *newbinding = new Evtmapper_binding;

	newbinding->type=binding_key;
	newbinding->sdlsym = sdlsym;

	newbinding->cmdfunction = (CMDFUNCTION::Function)cmdfunction;
	newbinding->config_name = config_name;
	newbinding->display_name = display_name;
	push_back(newbinding);
}

void Evtmapper_bindings::add_joybuttonbinding(int joystick, int button, int cmdfunction, char *config_name, char *display_name) {
	Evtmapper_binding *newbinding = new Evtmapper_binding;

	newbinding->type=binding_joybutton;
	newbinding->buttoninfo.joystick=joystick;
	newbinding->buttoninfo.button=button;

	newbinding->cmdfunction = (CMDFUNCTION::Function)cmdfunction;
	newbinding->config_name = config_name;
	newbinding->display_name = display_name;		
	push_back(newbinding);
}

Evtmapper_bindings::iterator Evtmapper_bindings::find_by_sdlsym(SDLKey sdlsym)
{
 	iterator i=begin();
	while (i != end()) {
	  if ((*i)->type==binding_key && (*i)->sdlsym == sdlsym)
	    return i;
  	i++;
	}
	return end();
}

Evtmapper_bindings::iterator Evtmapper_bindings::find_by_joybutton(int joy, int button)
{
 	iterator i=begin();
	while (i != end()) {
	  if ((*i)->type==binding_joybutton &&
	      (*i)->buttoninfo.joystick==joy &&
	      (*i)->buttoninfo.button==button)
	    return i;
  	i++;
	}
	return end();
}

Evtmapper_bindings::iterator Evtmapper_bindings::find_by_function(CMDFUNCTION::Function cmdfunction)
{
 	iterator i=begin();
	while (i != end()) {
    if ((*i)->cmdfunction == cmdfunction)
			return i;
  	i++;
	}
	return end();
}
