/***************************************************************************
                          evtmapper_bindings.h  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#include "keymapper.h"
#include <list>
#include <string>

enum Evtmapper_bindingtype {binding_key, binding_joybutton};

typedef struct Evtmapper_joybuttoninfo {
	int joystick;
	int button;
};

typedef struct Evtmapper_binding {
	Evtmapper_bindingtype type;
        union {
	  SDLKey sdlsym;
	  Evtmapper_joybuttoninfo buttoninfo;
	};
	CMDFUNCTION::Function cmdfunction;
	std::string config_name;
	std::string display_name;
};

//just a class for storing the actual mappings,
class Evtmapper_bindings : public std::list<Evtmapper_binding*> {
public:
	~Evtmapper_bindings();
	void add_keybinding(SDLKey sdlsym,int cmdfunction, char *config_name, char *display_name);
	void add_joybuttonbinding(int joystick, int button, int cmdfunction, char *config_name, char *display_name);
	iterator find_by_sdlsym(SDLKey sdlsym);
	iterator find_by_joybutton(int joystick, int button);
	iterator find_by_function(CMDFUNCTION::Function cmdfunction);
};
