/***************************************************************************
                          obj_smoke.cpp  -  description
                             -------------------
    begin                : Fri Apr 5 2002
    copyright            : (C) 2002 by Maciek Fijalkowski
    email                : fijaljr@linuxfreemail.com 
 ***************************************************************************/


#include "obj_smoke.h"
#include "all.h"

#define LIFE_TIMER 1

Obj_smoke::Obj_smoke(World *world_, int id) : Obj_base(world_,id)
{
	smoke_map_ready = false;
}
Obj_smoke::~Obj_smoke()
{
}
       
void Obj_smoke::init(int owner, float xpos_, float ypos_, int size_)
{
	ownerid = owner;
	xpos = xpos_;
	ypos = ypos_;
	xspeed = 0;
	yspeed = 0;
	yaccel = -DEFAULT_ACCEL/10;
	createtime=world->gettime();
	size=size_;
	air_resistance=0.007;
}

void Obj_smoke::draw(Viewport *viewport)
{
	/*	int x0 = ROUND(xpos)-viewport->xpos;
	int y0 = ROUND(ypos)-viewport->ypos;
	int32 *target;

	int size = (int)(age () * SMOKE_SIZE);
	for ( int x = -size + x0; x < size + x0; ++x )
		for ( int y = -size + y0; y < size + y0; ++y ) {
			if ( (x - x0)*(x - x0) + (y - y0)*(y - y0) < size*size ) {
				target = viewport->get_pixels_write()+x+y*viewport->get_xsize();
				if ( rand () % 10 < 4 )
					*target = 0xaaaaaa | PF_TYPE_HOLE;
			}
			}*/

	if ( !smoke_map_ready )
	{
		int size = SMOKE_SIZE;
		for ( int x = 0; x < 2 * size + 1; ++x )
			for ( int y = 0; y < 2 * size + 1; ++y ) {
				if (( (x - size)*(x - size) + (y - size)*(y - size) < size*size ) && ( rand () % 100 < 12 ))
					smoke_map [ x ] [ y ] = 1;
				else
					smoke_map [ x ] [ y ] = 0;
			}
		smoke_map_ready = true;
	}
	// ok, smoke has been made

	int x0 = ROUND(xpos)-viewport->xpos;
	int y0 = ROUND(ypos)-viewport->ypos;
	int32 *target;

	for ( int x = -SMOKE_SIZE; x < SMOKE_SIZE; ++x )
		for ( int y = -SMOKE_SIZE; y < SMOKE_SIZE; ++y ) {
			//			logmsg ( lt_debug , "sx = %i sy = %i map = %i" , x , y , smoke_map [ x + SMOKE_SIZE ] [ y + SMOKE_SIZE ] );
			if ( smoke_map [ x + SMOKE_SIZE ] [ y + SMOKE_SIZE ] ) {
				int sx = (int)(age () * x) + x0;
				int sy = (int)(age () * y) + y0;
				//				logmsg ( lt_debug , "sx = %i sy = %i" , sx , sy );
				if (sx >= 0 && sy >= 0 && sx < viewport->get_xsize() && sy < viewport->get_ysize()) {
					target = viewport->get_pixels_write()+sx+sy*viewport->get_xsize();
					*target = 0xaaaaaa | PF_TYPE_HOLE;
				}
			}
		}
}

void Obj_smoke::serialize(Serializer *serializer)
{
	Obj_base::serialize(serializer);
       
	serializer->rw(size);
}

void Obj_smoke::server_think()
{
	Serverworld *serverworld = (Serverworld *)world;
       
	Map_hit hit = update_simple(false); //this calls client_think() for us and checks for collisions

	if ( age() > LIFE_TIMER )
		done = true;
}

